# Devil (pre-compiled for Windows x64)

**This is a pre-compiled version of the [Devil](https://www.npmjs.org/package/devil) ([GitHub](https://github.com/newton-software/devil)) package. If you have Visual Studio 2010 Pro, please consider the normal package, rather than this one.**

**This version works only on 64bit system, only on Windows and only with NodeJS 0.10.x. We will publish more pre-compiled versions if there is interest.**

**Please don't install this one, if you have the regular version and vice versa.**

## Installation

```sh
npm install -g devil-windows
```

## Usage

Simply use the command:

```sh
devil
```

Or, in case you have a local install:

```sh
node /path/to/devil
```

* **You don't have to start your application separately. Just start Devil and run your script from it.**
* **After Devil starts, you have to select a file from your computer (or the server in case of remote debugging) and hit the run button.**

It will start a server and a client and you can start doing your job. If you want more advanced usage, try **--help** for more info. The port and host of the server are configurable.
You can also start the program as a server or client only if you want remote debugging.

#### Just try it out

We have added a test application, just to try out Devil. After starting Devil, just enter **../../testapp** or **/path/to/devil/testapp** and run it. It has some basic functionality for testing.

#### Remote debugging

You can use Devil to debug an application running remotely. You have to install the module both on the "server" machine (the computer that runs your node.js app, that you want to debug)
and the "client" (usually your computer). Start the server with:

```sh
devil -s -h 0.0.0.0
```

This will start Devil without the client, listening on any IP. Then, run the client from your computer with:

```sh
devil -c -h [IP]
```

Where [IP] is the server's IP.

## License
The MIT License (MIT)

Copyright (c) 2014 Newton Soft Ltd <dev@newton.codes>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
